module HsModuleMaps where
import HsModule
import MUtils
import HsIdent(seqHsIdent)

instance Functor HsImportDeclI where
  fmap f (HsImportDecl s m q as optspec) =
    HsImportDecl s m q as (fmap (apSnd (map (fmap f))) optspec)

instance Functor HsExportSpecI where
  fmap f e =
    case e of
      EntE espec -> EntE (fmap f espec)
      ModuleE mn -> ModuleE mn

instance Functor EntSpec where
  fmap f e =
    case e of
      Var i -> Var (f i)
      Abs i -> Abs (f i)
      AllSubs i -> AllSubs (f i)
      ListSubs i is -> ListSubs (f i) (map (fmap f) is)

--------------------------------------------------------------------------------

mapDecls f (HsModule loc name exps imps ds) = HsModule loc name exps imps (f ds)
seqDecls (HsModule loc name exps imps ds)   = HsModule loc name exps imps # ds

seqImportDecl (HsImportDecl s m q as optspec) =
  HsImportDecl s m q as # seqMaybe (fmap (apSndM (mapM seqEntSpec)) optspec)

seqExportSpec e =
  case e of
    EntE espec -> EntE # seqEntSpec espec
    ModuleE mn -> return (ModuleE mn)

seqEntSpec e =
  case e of
    Var i -> Var # i
    Abs i -> Abs # i
    AllSubs i -> AllSubs # i
    ListSubs i is -> ListSubs # i <# mapM seqHsIdent is
