module SrcLoc(
    SrcLoc(..), -- source location data type
    HasSrcLoc(..), -- source location class
    srcFile,
    loc0)       -- :: SrcLoc, initial dummy location
  where

data SrcLoc = SrcLoc FilePath Int Int -- (Source file, line, column)
  deriving (Eq,Ord,Show,Read)

class HasSrcLoc syntax where 
  srcLoc :: syntax -> SrcLoc

srcFile x = case srcLoc x of SrcLoc path _ _ -> path

loc0 = SrcLoc "__unknown__" 0 0

instance HasSrcLoc s => HasSrcLoc [s] where
  srcLoc [] = loc0
  srcLoc (x:xs) = srcLoc x

instance HasSrcLoc SrcLoc where srcLoc = id
