module TiP where
import HasBaseStruct
import BaseSyntaxStruct
import TI
import TiLit()
import TiFields(tcFieldsPat)
import TiPrelude
import MUtils

instance HasId i (PI i p) where
  ident = HsPId
  isId (HsPId x) = Just x
  isId _ = Nothing

instance (Fresh i,TypeId i,ValueId i,
          TypeCheck i inp (Typed i outp),HasLit HsLiteral outp,
	  HasTypeApp i outp, HasBaseStruct outp (PI i outp))
	 => TypeCheck i (PI i inp) (Typed i outp) where tc = tcP

tcP p =
  case p of
    HsPId n                -> inst n
--  HsPLit l               -> emap hsPLit # tcLit0 l
    HsPLit s l             -> tc l
    HsPNeg s l             -> inst prelNegate `tapp` tc l
    HsPInfixApp x op z     -> inst op `tapp` tc x `tapp` tc z
    HsPApp nm ps           -> tcPApp nm ps
    HsPTuple ps            -> typedTuple # mapM tc ps
    HsPList ps             -> tcList =<< mapM tc ps
    HsPParen p             -> emap hsPParen # tc p
    HsPRec c fields        -> tcFieldsPat c fields
    HsPAsPat nm p          -> tcAsPat nm p
    HsPWildCard            -> (hsPWildCard:>:) # tfresh
    HsPIrrPat p            -> emap hsPIrrPat # tc p

tcPApp con ps = foldl tapp (inst (HsCon con)) (map tc ps)

tcAsPat x p =
  do tx <- varinst x
     p' :>: tp <- tc p
     tx =:= tp
     hsPAsPat x p' >: tp

pApp p1 p2 =
  case p1 of
    HsPId (HsCon c) -> HsPApp c [p2]
    HsPApp c ps -> HsPApp c (ps++[p2])
--  _ -> error ("pApp "++show p1)
