module CmdLineParser where

data Cmd cmd = Null cmd
             | Args String ([String] -> cmd)

fileArgs = Args "<files>"
fileArg f = fileArgs (mapM_ f)

doCmd (cmds,default_cmd) prg args =
  case args of
    [] -> default_cmd
    cmd:args ->
      case lookup cmd cmds of
	Nothing -> fail $ "Unknown command: "++cmd
	Just (cmd,_) ->
	  case (cmd,args) of
	    (Null   cmd,[]) -> cmd
	    (Args _ cmd,_ ) -> cmd args
	    _ -> fail "Malformed command"

usage prg cmds =
       unlines $
         ["Usage: "++prg++ " <command>",
          "  where <command> is one of:"]++
         map (("    "++).cmdusage) cmds
  where
    cmdusage (name,(cmd,res)) =
      case cmd of
        Null _      -> unwords [name,"--",res]
	Args args _ -> unwords [name,args,"--",res]
