module Deriving where
import DerivingEq
import DerivingShow
import DerivingBounded
import DerivingEnum
import DerivingOrd
import DerivingRead
import DerivingIx
import DerivingUtils
import PrettyPrint
import SrcLoc(srcLoc)

derive cl t =
    case lookup cl derivers of
      Nothing -> fail $ pp $"Don't know how to derive"<+>cl
      Just d -> d (srcLoc cl) =<< tinfo
  where
    tinfo =
      case idTy t of
	Type tinfo@TypeInfo{defType=Just tkind}
           | tkind `elem` [Data,Newtype] -> return (idName t,tinfo)
	_ -> fail $ pp $ "Deriving"<+>cl<>": this is not a data/newtype:"<+>t
{-
    conv tinfo@(TypeInfo d cs fs) = TypeInfo d (map convc cs) [] -- !!fields
      where
        convc (ConInfo c n optfs) =
          ConInfo (PNT (mkUnqual c) ConstrOf{} noSrcLoc)
		  n
		  Nothing -- !! field names are discarded
-}
derivers =
    [(pc "Eq",  deriveEq),
     (tc "Show",deriveShow),
     (pc "Bounded",deriveBounded),
     (pc "Enum",deriveEnum),
     (pc "Ord",deriveOrd),
     (tc "Read",deriveRead),
     (ixc "Ix",deriveIx)]
  where
    pc = prelType
    tc = topType (Module "PreludeText")
    ixc = topType (Module "Ix")
