module DerivingUtils(
    TypeInfo(..),DefTy(..),ConInfo(..),HsIdentI(..),IdTy(..),idTy,idName,
    fun,alt1,alt2,fun0,alt1',alt2',
    vars,app,apps,opapp,con,var,wild,(-::),str,lit,pair,
    hsLet,hsPApp,hsTyCon,HsLiteral(..),hsListComp,HsStmt(..),int,
    topVal,pv,prelVal,prelCon,oneDef,toDefs,noDef,localVal,prelType,topType,
    getBaseName,origModule,convCon,ModuleName(..),srcLoc,fakePos,
    isEnum,
    eq,andand,bool,false,true,conj
  ) where
import TiNames as TI
import TiClasses
import HasBaseStruct
import HasBaseName
import BaseSyntax
import TypedIds
import HsName
import UniqueNames(origModule)
import SrcLoc
import TiPNT()
import TiHsName()

default(Int)

vars x = [var (localVal (x++show n))|n<-[1..]]
apps args = foldl1 app args
pair x y = tuple [x,y]

opapp op e1 e2 = hsInfixApp e1 op e2
wild=hsPWildCard

fun = hsFunBind
alt2' src f p1 p2 e = HsMatch src f [p1,p2] (HsBody e) 
alt1' src f p e = HsMatch src f [p] (HsBody e) 

alt2 src f p1 p2 e = alt2' src f p1 p2 e noDef
alt1 src f p e = alt1' src f p e noDef

fun0 src f e = fun src [HsMatch src f [] (HsBody e) noDef]

isEnum = all isNullary
  where isNullary c = conArity c==0

convCon (t,ty) c0 = TI.conName (origModule c0) (getBaseName c0) t ty

e-::t = hsExpTypeSig loc0 e [] t
str = lit . HsString 


bool = prelType "Bool"
false = prelCon "False" bool boolInfo
true = prelCon "True" bool boolInfo
boolInfo = TypeInfo {defType=Just Data,
		     fields=[],
		     constructors=[bc "False",bc "True"]}
  where
    bc c = ConInfo (prelCon c bool boolInfo) 0 Nothing

eq = prelVal "=="
andand = pv "&&"

conj [] = con true
conj tsts = foldr1 (opapp andand) tsts

int = hsTyCon (prelType "Int")

fakePos :: SrcLoc -> Int -> SrcLoc
fakePos (SrcLoc path line col) n = SrcLoc (path++":derived_"++show col) line n
