module CertServerF(certServerF) where
import Fudgets
import AllFudgets(expandTabs)
import Char(isDigit)
import FudExtras(longTextConfirmPopupF)

certServerF =
   loopThroughRightF (absF certServerSP)
	             (delayF shF>+<longTextConfirmPopupF)

shF = --teeF show "shF" >==<
      (inputLinesSP -+- inputLinesSP) >^^=< subProcessF "sh" >=^< (++"\n")

certServerSP = loop
  where
    loop = get $ either ignore fromInput

    ignore _ = loop -- ignore output from shell while waiting for a cmd

    fromInput cmd =
      putSh (cmd ++ " ; echo +-+ $?") $
      getResult $ \ res ->
      output res $
      loop

getResult cont = loop []
  where
    loop acc = dispatch fromShell fromPopup ignore
      where
        ignore _ = loop acc -- ignore new cmds while a cmd is in progress

        fromShell l =
	  case l of
	    Left ('+':'-':'+':' ':s) | all isDigit s ->
	      cont (s=="0",reverse acc)
	    Right "+-+ Yes No" -> popup (msgTxt acc) (loop [])
	    --Right ('+':'-':'+':' ':s) -> cont (s=="0",reverse acc)
	    _ -> loop (l:acc)

        fromPopup (_,msg) = putSh (confirmString msg) (loop acc)

        msgTxt = map stripEither . reverse

output = put . Right
putSh = put . Left . Left
popup = put . Left . Right

dispatch fromShell fromPopup fromInput =
    get $ either (either fromShell fromPopup) fromInput

confirmString Confirm = "Yes"
confirmString Cancel = "No"

