module PfePlumbing(module PfePlumbing,module P) where
import AllFudgets as P(PixmapImage,Drawing,Gfx,Graphic(..),Button,Click,GfxCommand)

import PFE0 as P(ModuleNode,ModuleGraph)
import PFE_Certs as P(CertType,CertName,CertStatus)
import HsModule as P(ModuleName)
import HsTokens as P(Token)
--import RefsTypes(Orig,Refs,isDef)
import ScopeModule as P(XRefInfo)
import SrcLoc(srcLoc)
import ConvRefsTypes(simpSrcLoc)
import NameMaps(Role(..),Context(..))
import PfeBrowserMenu as P(MenuCmd)
import OpTypes(eqBy,cmpBy)
import CertServers as P(CertServers,Attrs,Name)

myname = "Programatica Haskell Browser"

type Refs=[XRefInfo]
type Orig=XRefInfo

type CertIcons = [(CertType,(PixmapImage,PixmapImage,PixmapImage))]
                           --(valid,invalid,unknown)
type Icons = (PixmapImage,CertIcons) -- (bad,certicons)
type CertsStatus = [(CertName,CertStatus)]

type SrcToken = (Token,((Int,Int),String))
newtype Label = Lbl {unLbl::(SrcToken,Maybe Orig)} --deriving (Show)

lblPos = fst.snd.fst.unLbl

isDefLbl (Lbl (_,Just ((r,_),_,_))) = isDef r
isDefLbl _ = False

isDef (Def (Instance _)) = False
isDef (Def _) = True
isDef _ = False

refPos :: XRefInfo -> (Int,Int)
addRefPos :: XRefInfo -> ((Int,Int),XRefInfo)
refPos r@(_,n,_) = simpSrcLoc (srcLoc n)
addRefPos r = (refPos r,r)

instance Eq Label where (==) = eqBy lblPos
instance Ord Label where compare = cmpBy lblPos

type LexDrawing = Drawing Label Gfx

data InfoWindow
  = CertInfo | CertTypes | Evidence | Exports | Interface | Pretty
  deriving (Eq,Show,Bounded,Enum)

data InfoLbl
   = CertLbl CertName | CertCmd String | CreateCert (CertName,String)
   | CertEdit (CertType,(CertName,Attrs))
   deriving (Eq,Ord,Show)

type InfoDrawing = Drawing InfoLbl Gfx

instance Graphic InfoWindow where measureGraphicK = measureGraphicK . show

type PfeMenuCmd = MenuCmd InfoWindow

type FromMenuBar = PfeMenuCmd
type FromInfoWindows = Either (InfoWindow,Bool) (InfoWindow,InfoLbl)
type FromGraph = ModuleNode
type FromNodeInfo = Either ModuleName FilePath
type FromSource = (Maybe Button,Label)
type FromRefs = InfoLbl
type FromMessagePopup = Click
type FromModuleDisp = Either FromNodeInfo (Either FromSource FromRefs)

type ToModuleDisp = Either ToNodeInfo (Either ToSource ToRefs)
toSource = _toModuleDisp . Right . Left
toRefs = _toModuleDisp . Right . Right

type FromPopups = Either (Either FromMessagePopup FromNewCertPopup) FromCertAttrsEditors
type ToPopups = Either (Either ToMessagePopup ToNewCertPopup) ToCertAttrsEditors

type FromCertServer = (Bool,[Either String String])
type ToCertServer = String

type ToNewCertPopup = (CertIcons,(CertName,String))
type FromNewCertPopup = (CertType,(CertName,String))

type ToCertAttrsEditors = Either CertServers (CertType,(CertName,Attrs))
type FromCertAttrsEditors = (CertType,(CertName,Attrs))

type ToMenuBar = PfeMenuCmd
type ToInfoWindows = (InfoWindow,Either Bool InfoDrawing)
type ToGraph = ModuleGraph
type ToNodeInfo = (ModuleNode,[ModuleName]) -- (...,imported by)
type ToSource = Either (FilePath,Icons,ModuleNode,[SrcToken],Refs,CertsStatus)
		       (GfxCommand Label LexDrawing)
type ToRefs = InfoDrawing
type ToMessagePopup = [String]


type In  = Either (Either (Either FromMenuBar FromInfoWindows)
			  (Either FromGraph FromModuleDisp))
		  (Either FromPopups FromCertServer)
type Out = Either (Either (Either ToMenuBar ToInfoWindows)
                          (Either ToGraph ToModuleDisp))
	          (Either ToPopups ToCertServer)
toMenuBar = toOut . Left . Left . Left
toInfoWindows = toOut . Left  . Left . Right
_toModuleDisp = toOut . Left . Right . Right
toOut = Right -- see FudgetIOMonad1
