{-+
Chase source files through imports, assuming module names and file names agree.
-}
module PfeChase where
import Prelude hiding (putStrLn)
import List(nub,partition,(\\))
import Monad(unless)

import HsName(ModuleName(..))

--import Pfe0Cmds
import PFE0

import CmdLineParser
import AbstractIO
import PathUtils
import DirUtils(expand)
import PrettyPrint
import MUtils

pfeChaseCmds = [("chase",(fileArgs findMissing,"look for imported modules in given files/directories"))]

findMissing args =
  do checkProject
     fg <- getCurrentModuleGraph
     allfiles <- map normf # expand args
     let (ignored,newfiles) 
		 = partition (null.moduleName) (allfiles \\ map fst fg)
	 missing = nub [i|(_,(_,is))<-fg,i<-is] \\ map (fst.snd) fg
	 new = [(f,Module (moduleName f))|f<-newfiles]

     unless (null ignored) $ pput $ "Ignoring:"<+>fsep ignored
     files <- map fst # chase fg missing new
     saveSrcList files
     projectStatus -- will report modules that are still missing
  where
    chase fg missing new =
	case missing of
	  [] -> return fg
	  m:ms ->
	      case partition ((==m).snd) new of
		([],_) -> chase fg ms new -- didn't find m, skip & report later
		((f,_):fms,new') ->
		    do unless (null fms) $
		         pput $ "Using the first file for"<+>m<>":"<+>
			        fsep (f:map fst fms)
		       use f ms new'
      where
	use f ms new' =
	  do n@(m,is) <- moduleNode # preparseSourceFile f
	     let fg' = ((f,n):fg)
                 missing' = filter (isNew fg') is++ms
	     pput $ "Adding"<+>m<+>"from"<+>f
	     chase fg' missing' new'

    isNew fg m = null . filter ((m==).fst.snd) $ fg

-- from a path like foo/bar/M.hs, extract M
moduleName = reverse . takeWhile (/='/') . drop 1 . dropWhile (/='.') . reverse
